[Martin Escardo](https://www.cs.bham.ac.uk/~mhe).
Notes originally written for the module *Advanced Functional Programming* of the [University of Birmingham](https://www.birmingham.ac.uk/index.aspx), UK.

## [Preferred link to see these lecture notes](https://martinescardo.github.io/HoTTEST-Summer-School/)

## [Lecture Notes](./files/)

 1. [Introduction](files/introduction.lagda.md)
 1. Propositions as types and basic Martin-Löf type theory
    1. [Basic Martin-Löf Type Theory](files/curry-howard.lagda.md)
    1. [Empty type](files/empty-type.lagda.md) `𝟘`
    1. [Unit type](files/unit-type.lagda.md) `𝟙`
    1. [Binary type](files/binary-type.lagda.md) `𝟚`
    1. [Product types](files/products.lagda.md) `Π`
    1. [Sum types](files/sums.lagda.md) `Σ`
    1. [Binary products](files/binary-products.lagda.md) `_×_`
    1. [Binary sums](files/binary-sums.lagda.md) `_∔_`
    1. [Identity types](files/identity-type.lagda.md) `_≡_`
    1. [Natural numbers](files/natural-numbers-type.lagda.md) `ℕ`
    1. [Negation](files/negation.lagda.md) `¬`
    1. [Function extensionality](files/function-extensionality.lagda.md)
 1. [Propositions as types versus propositions as booleans](files/decidability.lagda.md)
 1. Isomorphisms `≅`
    1. [Definition and basic examples](files/isomorphisms.lagda.md)
    1. [Binary sums as a special case of sums](files/binary-sums-as-sums.lagda.md)
    1. [Binary products as a special case of products](files/binary-products-as-products.lagda.md)
 1. More types, their elimination principles, and their isomorphism with Basic MLTT types
    1. [Booleans](files/Bool.lagda.md) and [their manifestation as a Basic MLTT type](files/Bool-functions.lagda.md)
    1. [Finite types](files/Fin.lagda.md) and [their manifestation as a Basic MLTT type](files/Fin-functions.lagda.md)
    1. [Lists](files/List.lagda.md)
    1. [Vectors](files/Vector.lagda.md)
    1. [List and vector isomorphisms](files/vector-and-list-isomorphisms.lagda.md)
 1. More constructions and proofs with the above types:
    1. [Natural numbers](files/natural-numbers-functions.lagda.md)
    1. [Booleans](files/Bool-functions.lagda.md)
    1. [Finite types](files/Fin-functions.lagda.md)
    1. [Lists](files/List-functions.lagda.md)
    1. [Vectors](files/Vector-functions.lagda.md)
 1. [Hedberg's Theorem](files/Hedbergs-Theorem.lagda.md)

## [Index of all Agda files](files/all.lagda.md)

## Advanced further reading

 1. [Introduction to Homotopy Type Theory and Univalent Foundations (HoTT/UF) with Agda](https://www.cs.bham.ac.uk/~mhe/HoTT-UF-in-Agda-Lecture-Notes/HoTT-UF-Agda.html#contents).

## Follow the links

Each of the links above will take you to a different Agda module. You can use this to interactively explore the lecture notes: the Agda code is all type-checked (with the exception of some exercises which are left as holes, `{! !}`), and presented as hypertext. Click on an identifier to be taken to its definition.

## [HoTTEST School github repository](https://github.com/martinescardo/HoTTEST-Summer-School)
